﻿@model ShopWebApp.Models.CartIndexViewModel

@{
    ViewBag.Title = "Shopping Cart";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Shopping cart</h2>
<p>
    <a href="@Model.ReturnUrl" class="btn btn-outline-primary">Continue shopping</a>
</p>

<table class="table table-hover">
    <thead>
        <tr>
            <th>Product</th>
            <th>Price</th>
            <th>Quantity</th>
            <th>Total</th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model.Cart.Items)
        {
            <tr>
                <td>@item.Good.Title</td>
                <td>@item.Good.Price uah</td>
                <td>
                    @*button to decrease amount of items*@
                    <button type="button" data-id="@item.Good.Id" onclick="btnDecreaseClick(event)" class="btn btn-sm btn-outline-dark" @(item.Count == 1 ? "disabled" : "")>
                        <i class="fas fa-minus fa-xs"></i>
                    </button>
                    <span class="count-display">@item.Count</span>
                    @*button to increase amount of items*@
                    <button type="button" data-id="@item.Good.Id" onclick="btnIncreaseClick(event)" class="btn btn-sm btn-outline-dark">
                        <i class="fas fa-plus fa-xs"></i>
                    </button>
                </td>
                <td>@(item.Good.Price * item.Count) uah</td>
                <td>@Html.ActionLink("Remove", "RemoveFromCart", "Cart", new { id = item.Good.Id, returnUrl = Model.ReturnUrl }, new { @class = "btn btn-warning" })</td>
            </tr>
        }
    </tbody>
    <tfoot>
        @{
            var itemsInCartCount = int.Parse(Html.Action("GetItemsCount", "Cart").ToString());
            if (itemsInCartCount > 0)
            {
                <tr class="font-weight-bold">
                    <td></td>
                    <td></td>
                    <td></td>
                    <td class="text-right" style="font-size: larger;">
                        <h4>Total: @Model.Cart.GetTotalPrice() uah</h4>
                    </td>
                </tr>
                <tr>
                    <td colspan="4">
                        <a href="#" class="btn btn-success btn-lg float-right">Checkout</a>
                    </td>
                </tr>
            }
        }
    </tfoot>
</table>

@section scripts
{
    <script>
        function btnDecreaseClick(e) {
            e.stopPropagation();
            let clickedBtn = e.currentTarget;

            let url = `@Url.Action("DecreaseAmount")`;
            let requestData = { id: $(clickedBtn).data("id") };
            let xhr = $.post(url, requestData, (data, status) => {
                if (status == "success") {
                    let countDisplay = clickedBtn.parentElement.querySelector(".count-display");
                    $(countDisplay).text(data.count);
                    if (data.count <= 1) {
                        $(clickedBtn).attr("disabled", true);
                    }
                }
                else {
                    console.log(data);
                }
            }, "json");
        }


        function btnIncreaseClick(e) {
            e.stopPropagation();
            let clickedBtn = e.currentTarget;

            let url = `@Url.Action("IncreaseAmount")`;
            let requestData = { id: $(clickedBtn).data("id") };
            let xhr = $.post(url, requestData, (data, status) => {
                if (status == "success") {
                    let countDisplay = clickedBtn.parentElement.querySelector(".count-display");
                    $(countDisplay).text(data.count);
                    if (data.count > 1) {
                        let btnDec = clickedBtn.parentElement.querySelector("button");
                        $(btnDec).removeAttr("disabled");
                    }
                }
                else {
                    console.log(data);
                }
            }, "json");
    }

    </script>
}
